<template>
	<v-container class="sampling-collection-list flex-grow-1" :class="{ 'px-0': $vuetify.breakpoint.smAndDown }">
		<v-container class="d-flex justify-space-between align-end">
			<h3>In Progress</h3>
			<import-data-button buttonText="Import" />
		</v-container>
		<v-skeleton-loader v-if="draftsAreLoading" type="card" />
		<v-card v-if="draftsAreLoaded" rounded="lg" class="overflow-hidden">
			<v-card-text v-if="draftsHaveError">
				There was an error loading your sampling collections in progress. Please refresh.
			</v-card-text>
			<v-card-text v-else-if="draftSamplingCollections.length === 0 && !draftsHaveError">
				You do not have any sampling collections in progress.
			</v-card-text>
			<v-list v-else>
				<v-list-item-group>
					<v-list-item
						active-class="primary--text text--accent-4"
						three-line
						v-for="samplingCollection in draftSamplingCollections"
						:key="samplingCollection.id"
						:value="samplingCollection.id"
					>
						<sampling-collection-list-item-content :id="samplingCollection.id" />
						<v-list-item-action>
							<sampling-collection-delete :id="samplingCollection.id" />
						</v-list-item-action>
					</v-list-item>
				</v-list-item-group>
			</v-list>
		</v-card>
		<v-container class="d-flex justify-space-between align-end mt-4">
			<h3>Submitted</h3>
			<download-lab-inventory-button
				v-if="resourcesAreLoaded && !resourcesHaveError && submittedSamplingCollections.length"
				:sampling-collection-ids="selectedCollections"
			/>
		</v-container>
		<v-skeleton-loader v-if="resourcesAreLoading" type="card" />
		<v-card v-if="resourcesAreLoaded" rounded="lg" class="overflow-hidden">
			<v-card-text v-if="resourcesHaveError">
				There was an error loading submitted sampling collections. Please refresh or continue offline.
			</v-card-text>
			<v-card-text v-else-if="submittedSamplingCollections.length === 0 && !resourcesHaveError">
				You have not submitted any sampling collections yet.
			</v-card-text>
			<v-list v-else>
				<v-list-item-group v-model="selectedCollections" multiple>
					<v-list-item
						active-class="primary--text text--accent-4"
						three-line
						v-for="samplingCollection in submittedSamplingCollections"
						:key="samplingCollection.id"
						:value="samplingCollection.id"
					>
						<template v-slot:default="{ active }">
							<v-list-item-action class="d-flex flex-row">
								<v-checkbox :input-value="active" color="primary accent-4"></v-checkbox>
							</v-list-item-action>
							<sampling-collection-list-item-content :id="samplingCollection.id" />
						</template>
					</v-list-item>
				</v-list-item-group>
			</v-list>
		</v-card>
	</v-container>
</template>

<script lang="ts">
import { defineComponent, ref } from '@vue/composition-api';
import DownloadLabInventoryButton from './DownloadLabInventoryButton.vue';
import SamplingCollectionListItemContent from './SamplingCollectionListItemContent.vue';
import SamplingCollectionDelete from './SamplingCollectionDelete.vue';
import ImportDataButton from '@/components/common/ImportDataButton.vue';
import { useAllResources } from '@/store/modules/resources';
import { useAllSamplingCollections } from '@/store/modules/samplingCollections';

export default defineComponent({
	components: {
		DownloadLabInventoryButton,
		ImportDataButton,
		SamplingCollectionListItemContent,
		SamplingCollectionDelete,
	},
	setup(_, { root }) {
		const selectedCollections = ref([]);

		const {
			isLoaded: resourcesAreLoaded,
			isLoading: resourcesAreLoading,
			hasError: resourcesHaveError,
			samplingCollections: submittedSamplingCollections,
		} = useAllResources(root.$store);
		const {
			isLoaded: draftsAreLoaded,
			isLoading: draftsAreLoading,
			hasError: draftsHaveError,
			samplingCollections: draftSamplingCollections,
		} = useAllSamplingCollections(root.$store);

		return {
			draftsAreLoaded,
			draftsAreLoading,
			draftsHaveError,
			resourcesAreLoaded,
			resourcesAreLoading,
			resourcesHaveError,
			submittedSamplingCollections,
			draftSamplingCollections,
			selectedCollections,
		};
	},
});
</script>

<style></style>
